# **********************************************************************
# Copyright 2015 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import uuid


class LogicalRouter(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "uuid": None,
            "vdr_id": None,
            "instance_type": None,
            "num_lifs": None,
            "num_routes": None,
            "num_routesv6": None,
            "state": None,
            "num_next_hop_in_hash": None,
            "gen_num": None,
            "cp_active": None,
            "edge_active": None,
            "enable_FLE": None,
            "enable_frag": None,
            "enable_icmp_PMTU": None,
            "enable_icmp_echo": None,
            "enable_bcast_icmp_echo": None,
            "enable_icmp_rate_limit": None,
            "default_ttl": None,
            "arp_timeout": None,
            "arp_protect_timer": None,
            "dp_log_level": None,
            "garp_support": None,
            "ecmp_method": None,
            "max_arp_entries": None,
            "num_arp_entries": None,
            "arp_limit_overridden": None,
            "max_FLEntries": None,
            "mcast_routing": None,
            "mrdID": None,
            "numMcastRouters": None,
            "mcastRouters": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterLif(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ifuuid": None,
            "dvs_id": None,
            "ips": None,
            "numIpv6Addr": None,
            "DI_ip": None,
            "mac": None,
            "vni_type": None,
            "vni": None,
            "flags": None,
            "state": None,
            "designated_instance": None,
            "dhcp_relay_info": None,
            "mode": None,
            "cp_enable": None,
            "slaacState": None,
            "mcastRoutingState": None,}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterRoute(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "dest_ip": None,
            "dest_mask": None,
            "prefix": None,
            "flags": None,
            "refcnt": None,
            "use": None,
            "next_hops": None,
            "origin": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterMulticastGroupInfo(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "mcast_ip": None,
            "outer_mcast_ip": None,
            "is_local": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterMulticastLocalReceiverInfo(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "lifName": None,
            "vniType": None,
            "vni": None,
            "expireSec": None,
            "upTimeSec": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterNextHop(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "gw_ip": None,
            "ifuuid": None,
            "up_time": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterNeighbor(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "ip": None,
            "mac": None,
            "flags": None,
            "state": None,
            "uptime": None,
            "source_port_id": None,
            "refcnt": None,
            "ifuuid": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterLifStats(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "pktSystemError": None,
            "pktTxRefError": None,
            "deferredFree": None,
            "pktRxUnicast": None,
            "bytesRxUnicast": None,
            "pktTxUnicast": None,
            "bytesTxUnicast": None,
            "pktPolicyTxUnicast": None,
            "bytesPolicyTxUnicast": None,
            "pktRxBroadcast": None,
            "bytesRxBroadcast": None,
            "pktTxBroadcast": None,
            "bytesTxBroadcast": None,
            "pktRxMulticast": None,
            "bytesRxMulticast": None,
            "droppedRx": None,
            "pktTxDynResPool": None,
            "pktRx": None,
            "pktTx": None,
            "nbrNotFound": None,
            "arpReqRx": None,
            "arpReqTx": None,
            "arpRspRx": None,
            "arpRspTx": None,
            "garpRx": None,
            "garpTx": None,
            "arpProbeTx": None,
            "pktForward": None,
            "pktFragmented": None,
            "pktConsumed": None,
            "pktIgnored": None,
            "dropsTtl": None,
            "dropsCsum": None,
            "dropsHoldPkt": None,
            "dropsBlackholed": None,
            "allocFail": None,
            "icmpEchoRx": None,
            "icmpEchoTx": None,
            "icmpTtlExpTx": None,
            "icmpDestNetUnreach": None,
            "icmpDestHostUnreach": None,
            "icmpRedirect": None,
            "proxyArpSrcNotLif": None,
            "proxyArpReq": None,
            "errNoRoute": None,
            "dropsRpf": None,
            "ipv6PktRx": None,
            "ipv6PktTx": None,
            "ipv6NbrNotFound": None,
            "ipv6NsRx": None,
            "ipv6NsTx": None,
            "ipv6NaRx": None,
            "ipv6NaTx": None,
            "ipv6UnsolicitedNaRx": None,
            "ipv6UnsolicitedNaTx": None,
            "ipv6NeighProbeTx": None,
            "ipv6PktForward": None,
            "ipv6PktConsumed": None,
            "ipv6PktIgnored": None,
            "ipv6DropsTtl": None,
            "ipv6DropsCsum": None,
            "ipv6DropsHoldPkt": None,
            "ipv6DropsBlackholed": None,
            "ipv6AllocFail": None,
            "icmpv6EchoRx": None,
            "icmpv6EchoTx": None,
            "icmpv6TtlExpTx": None,
            "icmpv6DestNetUnreach": None,
            "icmpv6DestHostUnreach": None,
            "icmpv6DestPortUnreach": None,
            "ipv6Redirect": None,
            "icmpv6ParamProblem": None,
            "ipv6ErrNoRoute": None,
            "ipv6DropsRpf": None,
            "ipv6DropsLinkLocalIp": None,
            "pktTxMulticast": None,
            "dropsUnsupported": None,
            "ipv6Frag6Current": None,
            "ipv6Frag6CurrentPktsRx": None,
            "ipv6Frag6TotalPktsTx": None,
            "ipv6Frag6Total": None,
            "ipv6Frag6TotalPktsRx": None,
            "ipv6HBHOptRx": None,
            "ipv6RTROptRx": None,
            "ipv6DESTOptRx": None,
            "igmpQueryRx": None,
            "igmpQueryForward": None,
            "igmpQuerySuppressed": None,
            "igmpReportRx": None,
            "igmpReportForward": None,
            "igmpReportSuppressed": None,
            "igmpLeaveRx": None,
            "igmpLeaveForward": None,
            "igmpLeaveSuppressed": None,
            "igmpUnsupported": None,
            "igmpIgnored": None,
            "igmpDrops": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterPbrPolicyTable(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "uuid": None,
            "table_id": None,
            "ref_cnt": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterPbrPolicy(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "dest_ip": None,
            "dest_mask": None,
            "flags": None,
            "refcnt": None,
            "action": None,
            "hitCount": None,
            "prefix": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class LogicalRouterLifPbrPolicyTableRef(object):
    def __init__(self, **kwargs):
        prop_defaults = {
            "policy_table_id": None,
            "next_hop_mac": None,
            "policy_type": None}
        for (prop, default) in list(prop_defaults.items()):
            setattr(self, prop, kwargs.get(prop, default))

    def json_repr(self):
        return self.__dict__


class PolicyTableId(object):
    def __init__(self, table_id):
        self.uuid = None
        self.id = None
        try:
            uuid.UUID(table_id)
            self.uuid = table_id
        except ValueError:
            self.id = table_id
