# **********************************************************************
# Copyright 2018 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import json

from cli.commands.cli_command_provider import CliCommandProvider
from cli.commands.lcp_common.nsx_proxy.client import get_nsxproxy_cli_output


class GetNsxProxyCentralLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyCentralLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_nsxproxy_cli_output("set/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class GetNsxProxyLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get-proxy/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[4]
        response = get_nsxproxy_cli_output("set-proxy/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class GetNsxProxyMetricsLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get-metrics/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyMetricsLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_nsxproxy_cli_output("set-metrics/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class GetNsxProxyNetLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get-net/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyNetLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_nsxproxy_cli_output("set-net/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class GetNsxProxyRpcLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get-rpc/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyRpcLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_nsxproxy_cli_output("set-rpc/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class GetNsxProxyNestDbLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        response = get_nsxproxy_cli_output("get-nestdb/loglevel")
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)


class SetNsxProxyNestDbLogLevel(CliCommandProvider):
    def __call__(self, cmd_list):
        log_level = cmd_list[5]
        response = get_nsxproxy_cli_output("set-nestdb/loglevel", [log_level])
        if response is None:
            return "MSG_NSXPROXY_LOG_LEVEL_FAILED"

        return "OK\n\n%s" % json.dumps(response)
