# **********************************************************************
# Copyright 2014 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import nsx_logging


lg = nsx_logging.getLogger("cli.utils.import_utils")


def get_class(module, class_name):
    """Retrieve class implementation given module and class name.

    Args:
        module: Python module where class is implemented.
        class_name: Name of class do retrieve.
    Return:
        Class implementaiton of specified class_name.
    """
    module_name = module.split(".")[-1]
    module_obj = __import__(module, globals(), locals(), [module_name])
    return getattr(module_obj, class_name)
