# Copyright (C) 2019 VMware, Inc. All rights reserved.
# -- VMware Confidential
import sha.config
from sha.contrib.action.abc_base import Action
from sha.core.channel.provider.alarm_provider import AlarmMsg

from sha.constants import ALARM_HUB

class Alarm(Action):
    _logger = sha.config.get_logger(__name__)

    @classmethod
    def do(cls, hubs, *args):
        def kernel(**kwargs):
            msg = AlarmMsg(kwargs["feature"],
                           kwargs["status"],
                           kwargs["event_type"] if "event_type" in kwargs else None,
                           kwargs["deleted_entity_list"] if "deleted_entity_list" in kwargs else None)
            cls._logger.debug('Alarm Action - send alarm msg: {} to alarm hub:{}'.format(msg, hubs[ALARM_HUB]))
            hubs[ALARM_HUB].send(msg)
        return kernel
