# Copyright (C) 2020-2021 VMware, Inc. All rights reserved.
# -- VMware Confidential

import copy
import sha.constants


class PluginStatus(object):
    def __init__(self, plugin_id, name, profile=None, status=sha.constants.PLUGIN_STATUS_TYPE_INVALID, detail=''):
        self.plugin_id = plugin_id
        self.name = name
        self.status = status
        self.detail = detail
        self.profile = profile

    def __repr__(self):
        return 'PluginStatus - plugin_id:{}, name:{}, status:{}, detail:{}, profile:{}'\
            .format(self.plugin_id, self.name, self.status, self.detail, self.profile)

    def __eq__(self, other):
        if not isinstance(other, PluginStatus):
            return False

        if self.plugin_id != other.plugin_id:
            return False

        if self.name != other.name:
            return False

        if self.status != other.status:
            return False

        if self.detail != other.detail:
            return False

        if self.profile != other.profile:
            return False

        return True
