# Copyright (C) 2020 VMware, Inc. All rights reserved.
# -- VMware Confidential

profile = data_store['profile']
metric_name = 'nsx.communication.manager-fqdn-lookup-failure-status'

if data_store['metrics'][metric_name] is not None:
    status_dict, deleted_entity_list = data_store['metrics'][metric_name]['value']
    event_type_id = feature_event_type_mappings.COMMUNICATION_MANAGER_FQDN_LOOKUP_FAILURE_EVENT_TYPE_ID

    Alarm(status={event_type_id: status_dict},
            feature="communication",
            event_type = 'manager_fqdn_lookup_failure',
            deleted_entity_list = deleted_entity_list)
else:
    logger.info('No {} metric: {}'.format(metric_name, data_store['metrics']))
